#ifndef MATRIX_H
#define MATRIX_H

/*
** ! Note: The arrays begin at index number 1 and NOT at index 0.
*/

#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>

/* Preproccessor Directives */
#define OK										1
#define	SET_NOT_INITIALIZED_VECTOR				-1
#define SET_DIANYSMA_OUT_OF_BOUNDS				-2
#define	GET_NOT_INITIALIZED_VECTOR				-3
#define GET_DIANYSMA_OUT_OF_BOUNDS				-4
#define SET_NOT_INITIALIZED_MATRIX				-5
#define SET_PINAKA_OUT_OF_BOUNDS				-6
#define GET_NOT_INITIALIZED_MATRIX				-7
#define GET_PINAKA_OUT_OF_BOUNDS				-8
#define SWAP_LINES_OUT_OF_BOUNDS				-9
#define SWAP_COLUMNS_DIANYSMA_OUT_OF_BOUNDS		-10
#define SWAP_COLUMNS_PINAKA_OUT_OF_BOUNDS		-11
#define GET_COLUMN_PINAKA_UNDEFINED				-12
#define GET_COLUMN_PINAKA_OUT_OF_BOUNDS			-13
#define GET_COLUMN_PINAKA_INCOMPATIBLE_TYPES	-14
#define SET_COLUMN_PINAKA_UNDEFINED				-15
#define SET_COLUMN_PINAKA_OUT_OF_BOUNDS			-16
#define SET_COLUMN_PINAKA_INCOMPATIBLE_TYPES	-17

/* Data Structures */
struct dianysma {
	double	* sthlh;
	int		theseis;
};

typedef struct dianysma DIANYSMA;
typedef DIANYSMA * DIANYSMAPTR;

struct pinakas {
	DIANYSMAPTR	* grammh;
	int			size;
};

typedef struct pinakas PINAKAS;
typedef PINAKAS * PINAKASPTR;

/*
** Functions for manipulation of arrays.
*/

DIANYSMAPTR Initialize_Dianysma (const int);
void		Destroy_Dianysma (DIANYSMAPTR);
int			Set_Dianysma (DIANYSMAPTR, const int, const double);
int			Get_Dianysma (DIANYSMAPTR, const int, double *);
int			Swap_Columns_Dianysma (DIANYSMAPTR, const int, const int);
void		Pollaplasiasmos_Dianysmatwn (DIANYSMAPTR, DIANYSMAPTR, double *);
PINAKASPTR	Initialize_Pinaka (const int, const int);
void		Destroy_Pinaka (PINAKASPTR);
int			Set_Pinaka (PINAKASPTR, const int, const int, const double);
int			Get_Pinaka (PINAKASPTR, const int, const int, double *);
int 		Swap_Lines (PINAKASPTR, const int, const int);
int			Swap_Columns_Pinaka (PINAKASPTR, const int, const int);
void		Pollaplasiasmos_Pinakwn (PINAKASPTR, PINAKASPTR, PINAKASPTR);
void		Pollaplasiasmos_Pinaka_Dianysmatos (PINAKASPTR, DIANYSMAPTR, DIANYSMAPTR);
int			Get_Column (PINAKASPTR, const int, DIANYSMAPTR);
int			Set_Column (PINAKASPTR, const int, DIANYSMAPTR);
void		Typwse_Pinaka (PINAKASPTR, char *);

#endif
